//+------------------------------------------------------------------+
//|                                                  OnChart Rsi.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkGray
#property indicator_color2 Gray
#property indicator_color3 Gray
#property indicator_color4 DarkGray
#property indicator_color5 Orange
#property indicator_color6 Orange
#property indicator_color7 LimeGreen
#property indicator_color8 LimeGreen
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2
#property indicator_style1 STYLE_DOT

//---- parameters
//
//
//
//

extern int RSIPeriod    = 14;
extern int RSIPriceType =  0;
extern int maPeriod     = 20;
extern int maMethod     =  1;
extern int maPrice      =  0;
extern int overBought   = 70;
extern int overSold     = 30;
extern string timeFrame = "Current time frame";

//---- buffers
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double bufupa[];
double bufupb[];
double bufdna[];
double bufdnb[];
int    TimeFrame;
int    atrTimeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,bufupa);
   SetIndexBuffer(5,bufupb);
   SetIndexBuffer(6,bufdna);
   SetIndexBuffer(7,bufdnb);


   TimeFrame = stringToTimeFrame(timeFrame);
   atrTimeFrame=PERIOD_D1;
   if (TimeFrame >= atrTimeFrame)
      switch (TimeFrame)
         {
            case PERIOD_D1: atrTimeFrame = PERIOD_W1; break;
            default:        atrTimeFrame = PERIOD_MN1;
         }
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);
   
//----
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit=MathMax(Bars-counted_bars,TimeFrame/Period());   
      

   //----
   //
   //
   //
   //

      if (ExtMapBuffer4[limit]>ExtMapBuffer2[limit]) CleanPoint(limit,bufupa,bufupb);
      if (ExtMapBuffer4[limit]<ExtMapBuffer3[limit]) CleanPoint(limit,bufdna,bufdnb);
      for(int i = limit; i>=0; i--)
      {
         int r = iBarShift(NULL,atrTimeFrame,Time[i]);
         int y = iBarShift(NULL,   TimeFrame,Time[i]);
               double avgRange  = iATR(NULL,atrTimeFrame,maPeriod,r);
               double maValue   = iMA(NULL,TimeFrame,maPeriod,0,maMethod,maPrice,y);
               double rsiValue  = iRSI(NULL,TimeFrame,RSIPeriod,RSIPriceType,y);
               ExtMapBuffer1[i] = maValue;
               ExtMapBuffer2[i] = maValue+(avgRange*(overBought-50)/100);
               ExtMapBuffer3[i] = maValue+(avgRange*(overSold  -50)/100);
               ExtMapBuffer4[i] = maValue+(avgRange*(rsiValue  -50)/100);
               bufupa[i]        = EMPTY_VALUE;
               bufupb[i]        = EMPTY_VALUE;
               bufdna[i]        = EMPTY_VALUE;
               bufdnb[i]        = EMPTY_VALUE;
               if (ExtMapBuffer4[i]>ExtMapBuffer2[i]) PlotPoint(i,bufupa,bufupb, ExtMapBuffer4);
               if (ExtMapBuffer4[i]<ExtMapBuffer3[i]) PlotPoint(i,bufdna,bufdnb, ExtMapBuffer4);
         }
   return(0);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
                  
         //
         //
         //
         //
         //
                                 
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

